!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs (and fits smooth curve to) periodic orbits.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item This routine prepares initial guesses for the location of the periodic orbits, which are found using \verb+pq00aa+ by field line following.
!latex \item Periodicities are selected in then input file, $(p_1,q_1,p_2,q_2)=$\verb!pqirr(1:4,:)!.
!latex       Beginning from these rationals (which should be neighboring), \verb!pqirr(5,:)! mediants will also be located ;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pq01aa( lvol )

  use constants, only : zero, quart, half, one, two, pi2, goldenmean

  use fileunits, only : ounit

  use inputlist, only : Wpq01aa,  Nfp,  Nvol, iota, oita, npq

  use cputiming, only : Tpq01aa

  use allglobal, only : cpus, myid, pqorbit

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS 

  INTEGER, intent(in) :: lvol

  INTEGER              :: nc, ncok, ipqfail, pp, qq
  REAL                 :: low, upp, lowupp(2), iotal, iotau, liota

  BEGIN(pq01aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
#ifdef DEBUG
  FATALMESS(pq01aa, lvol.lt.1 .or. lvol.gt.Nvol, invalid volume )
#endif
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  low = - one ; upp = + one ; lowupp = (/ low, upp /) ! this will set search region;

  FATALMESS(pq01aa, lvol.eq.1, need to supply lower bound for rational search)

  iotal = oita(lvol-1) ; iotau = iota(lvol)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ncok = 0 ! this will count how many selected rationals are within transform range;
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do nc = 1, npq(lvol) ! loop over convergents;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   pp = pqorbit(lvol,nc)%pq(1)
   qq = pqorbit(lvol,nc)%pq(2)! * Nfp
   
   liota =  ( pp * Nfp ) * one / qq ! shorthand;
   
   if( ( liota - iotal ) * ( liota - iotau ) .ge. zero ) then ; write(ounit,1001) myid, lvol, pp, qq, pp*one/qq ; cycle ! not within range;
   else                                                       ; ncok = ncok+1
   endif
   
1001 format("pq01aa : "10x  " : myid=",i3," ; lvol=",i3," ; ",i3," /"i4" ="f9.6" ; not in range ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   if( ncok.gt.2 ) then
    if( abs(pqorbit(lvol,nc-1)%residue).gt.one ) exit ! residues are getting too large; irrational surface unlikely to exist;
   endif
   
   if( ncok.gt.2 ) then ; low = minval(lowupp) ; upp = maxval(lowupp) ; pqorbit(lvol,nc)%so = half * ( low + upp ) ! update search bound and initial guess; 14 Nov 12;
   endif
   
   if( Wpq01aa ) write(ounit,1002) myid, lvol, nc, pp, qq, pqorbit(lvol,nc)%to, low, pqorbit(lvol,nc)%so, upp
   
   WCALL(pq01aa,pq00aa,( lvol, nc, low, upp, ipqfail ) ) ! locate periodic orbit; before calling pq00aa, need to ensure that to and so are correctly set;
    
   if( Wpq01aa ) write(ounit,1002) myid, lvol, nc, pp, qq, pqorbit(lvol,nc)%to, low, pqorbit(lvol,nc)%so, upp, pqorbit(lvol,nc)%ok, pqorbit(lvol,nc)%residue
   
1002 format("pq01aa : "10x" : myid=",i3," ; lvol=",i3," ; nc=",i3," ; (",i3," ,"i4" ) ; to="f9.6" ; [low,so,upp]=["f9.6" ,"f9.6" ,"f9.6" ] ;":" ok="i2" ; R="f9.4" ;")
    
   if( ipqfail.ne.0 ) exit ! failed to locate periodic orbit;
   
   lowupp(1:2)=(/ lowupp(2), pqorbit(lvol,nc)%so /) ! bounds for further searches; successive convergents should bound the irrational;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do nc = 1, npq(lvol); 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pq01aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pq01aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
